Package: scTGIF
Type: Package
Title: Cell type annotation for unannotated single-cell RNA-Seq data
Version: 1.25.0
Authors@R: person("Koki", "Tsuyuzaki", role = c("aut", "cre"),
    email = "k.t.the-answer@hotmail.co.jp")
Depends: R (>= 3.6.0)
Imports: GSEABase, Biobase, SingleCellExperiment, BiocStyle, plotly,
        tagcloud, rmarkdown, Rcpp, grDevices, graphics, utils, knitr,
        S4Vectors, SummarizedExperiment, RColorBrewer, nnTensor,
        methods, scales, msigdbr, schex, tibble, ggplot2, igraph
Suggests: testthat
Description: scTGIF connects the cells and the related gene functions without
    cell type label.
License: Artistic-2.0
biocViews: DimensionReduction, QualityControl, SingleCell, Software,
        GeneExpression
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/scTGIF
git_branch: devel
git_last_commit: f7ab3ab
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-03
NeedsCompilation: no
Packaged: 2025-11-04 00:51:29 UTC; biocbuild
Author: Koki Tsuyuzaki [aut, cre]
Maintainer: Koki Tsuyuzaki <k.t.the-answer@hotmail.co.jp>

# scTGIF
Quality control and cell type annotation for unannotated single-cell RNA-Seq data

Installation of Dependent Packages
======
```r
# CRAN
install.packages("BiocManager", repos="http://cran.r-project.org")

# Bioconductor
library("BiocManager")
BiocManager::install(
    c("GSEABase", "Biobase", "SingleCellExperiment", "BiocStyle", "plotly",
    "tagcloud", "knitr", "msigdbr", "rmarkdown", "Rcpp", "S4Vectors",
    "SummarizedExperiment", "RColorBrewer", "nnTensor", "scales", "testthat"),
    update=TRUE, ask=FALSE)
```

Installation
======
```r
git clone https://github.com/rikenbit/scTGIF/
R CMD INSTALL scTGIF
```
or type the code below in the R console window
```r
install.packages("devtools", repos="http://cran.r-project.org")
library(devtools)
devtools::install_github("rikenbit/scTGIF")
```

# Prerequisites
- R (3.6.0 or higher)
- pandoc (1.12.3 or higher)

# License
Copyright (c) 2019 Koki Tsuyuzaki and RIKEN Bioinformatics Research Unit Released under the [Artistic License 2.0](http://www.perlfoundation.org/artistic_license_2_0).

# Authors
- Koki Tsuyuzaki
- Itoshi Nikaido

.convertGMT <- function (gmt, targetgeneid){
    Y <- matrix(0, nrow = length(targetgeneid), ncol = length(gmt))
    rownames(Y) <- targetgeneid
    colnames(Y) <- names(gmt)
    lapply(seq_len(length(gmt)), function(x) {
        Y[intersect(targetgeneid, gmt[[x]]@geneIds), x] <<- 1
    })
    return(Y)
}

.twoDimBin <- function(sce, common.geneid, assayNames){
    input <- .importAssays(sce, assayNames)
    input <- input[common.geneid, ]
    cID <- sce@metadata$hexbin[[1]]
    out <- t(apply(input, 1, function(x, cID){
        schex:::.make_hexbin_function(x, "mean", cID)
    }, cID=cID))
    colnames(out) <- paste0("Bin", seq(ncol(out)))
    out
}

.importAssays <- function(sce, assayNames){
    if(assayNames %in% names(assays(sce))){
        assays(sce)[[assayNames]]
    }else{
        stop("Please specify the valid assayNames (cf. names(assays(sce)))")
    }
}

.plot_hexbin_pattern <- function(sce, pattern, i){
    drhex <- data.frame(sce@metadata$hexbin$hexbin.matrix,
        pattern=pattern)
    drhex <- as_tibble(drhex)
    # Plot
    ggplot(drhex, aes_string("x", "y", fill = pattern)) +
    geom_hex(stat = "identity") +
    theme_classic() + theme(legend.position = "bottom") +
    ggtitle(paste0("Pattern", i)) + scale_fill_viridis_c() +
    labs(x = "Dim1", y = "Dim2") + theme(legend.title = element_blank())
}

# Title, Author, Data
.HEADER <- function(author, title){
    HEADER <- paste0("---\ntitle: XXXXX\n",
        "author: YYYYY\ndate:",
        " \"`r Sys.time()`\"\n",
        "output:\n",
        " BiocStyle::html_document:\n",
        "  toc_float: true\n",
        "vignette: >\n ",
        "%\\VignetteIndexEntry{Vignette Title}\n ",
        "%\\VignetteEngine{knitr::rmarkdown}\n ",
        "%\\VignetteEncoding{UTF-8}\n---\n")
    sub("YYYYY", author, sub("XXXXX", title, HEADER))
}

# 1. About Dataset and scTGIF Algorithm
.BODY1 <- paste0("\n\n# About scTGIF Algorithm\n\n",
    "![](Workflow.png)\n",
    "[scTGIF](https://bioconductor.org/packages/release/",
    "bioc/html/scTGIF.html) is the R/Bioconductor package ",
    "for the functional annotation of cells detected ",
    "by single-cell RNA-Seq (scRNA-Seq).\n\n",

    "In the analysis of scRNA-Seq data, ",
    "cell type annotation is one of the most time-consuming ",
    "and subjective step, which requires the domain specific knowledge of ",
    "the cell types.\n\n",

    "Detection of differentially expressed genes (DEGs) and ",
    "the following gene functional analysis such as enrichment analysis ",
    "or geneset enrichment analysis (GSEA), which is used in the bulk-level ",
    "omics analysis might be used for the annotation step ",
    "but this approach heavily depends on the cell type label. ",
    "In the scRNA-Seq analysis, however, the cell type label will updated ",
    "with the update of the knowledge about the cells ",
    "and this approach must be repeatedly performed in each update.\n\n",

    "scTGIF is developed for reducing this try-error cycle; ",
    "using joint non-negative matrix factorization, ",
    "this tool connects the cells and the related gene function ",
    "without the cell type label ",
    "and help users to grasp what kind of cells are included in the dataset. ",
    "scTGIF also contains some quality control metrics ",
    "and provides these as the reasons to remove the low-quality cells or ",
    "artifacts such as doublets.\n\n",

    "For more detail, visit the [vignette](https://bioconductor.org",
    "/packages/devel/bioc/vignettes/scTGIF/inst/doc/scTGIF.html)",
    " of [scTGIF](https://bioconductor.org/",
    "packages/release/bioc/html/scTGIF.html)"
    )

# 2. Global statistics and plots
.BODY2 <- paste0("\n\n# Global statistics and plots\n\n",
    "The result of scTGIF is saved as a R binary file",
    " (reanalysis.RData).\n",
    "```{r, message=F, warning=F}\n", # Top
    "load(\"reanalysis.RData\")\n",
    "# SingleCellExperiment object\n",
    "sce\n",
    "# Reduced data size\n",
    "metadata(sce)$ndim\n",
    "# The result of jNMF\n",
    "str(metadata(sce)$sctgif)\n",
    "# Reconstruction Error of jNMF\n",
    "head(metadata(sce)$recerror)\n",
    "tail(metadata(sce)$recerror)\n",
    "# Relative Change of jNMF\n",
    "head(metadata(sce)$relchange)\n",
    "tail(metadata(sce)$relchange)\n",
    "# Used Gene IDs for jNMF\n",
    "head(metadata(sce)$common.geneid)\n",
    "# Two matrices used for jNMF\n",
    "dim(metadata(sce)$X)\n",
    "dim(metadata(sce)$Y)\n",
    "# The number of bins of schex (Default: 40)\n",
    "metadata(sce)$nbins\n",
    "# GSEABase object for constructing the matrix Y\n",
    "metadata(sce)$gmt\n",
    "# Gene expression matrix\n",
    "is(input)\n",
    "dim(input)\n",
    "input[seq_len(2), seq_len(2)]\n",
    "# The result of 2D dimensional reduction (e.g. t-SNE)\n",
    "is(twoD)\n",
    "dim(twoD)\n",
    "head(twoD)\n",
    "```\n\n", # Bottom

    "\n\n## Two dimensional plot of all cells\n\n",
    "```{r, message=F, warning=F}\n", # Top
    "plot_ly(x=twoD[,1], y=twoD[,2], ",
    "type = \"scatter\", ",
    "text = rownames(twoD), ",
    "mode = \"markers\")\n",
    "```\n\n", # Bottom

    "\n\n## Distribution of core matrix values\n\n",
    "```{r, message=F, warning=F}\n", # Top
    "corenames <- vapply(seq_along(corevalue), ",
    "function(x){paste0(\"Pattern\", x)}, \"\")\n",
    "plot_ly(x=seq_along(corevalue), y=corevalue, ",
    "type=\"bar\", color=names(corevalue), text=corenames, ",
    "colors = c(\"#999999\", \"#E41A1C\"))\n",
    "```\n" # Bottom
    )

# 3. Attension maps and map related gene functions
.BODY3 <- function(ndim, out.dir){
    BODY3 <- paste0("# Attension maps and map related gene functions\n",
        "```{r, message=F, warning=F, message=F, warning=F}\n", # Top
        "library(\"plotly\")\n",
        "```\n" # Bottom
        )

    paste0(BODY3,
        paste(
            vapply(seq_len(ndim), function(x){
                paste(c(
                    paste0("## Pattern ", x, "\n"),
                    ##### H1 #####
                    "![](",
                    paste0("figures/Hex_", x, ".png"),
                    ")\n",
                    ##### H2 #####
                    "```{r, message=F, warning=F}\n", # Top
                    "d <- ",
                    x, "\n",
                    "value <- H2[,d]\n",
                    "term <- names(H2[,d])[order(value, decreasing=TRUE)]\n",
                    "value <- value[order(value, decreasing=TRUE)]\n",
                    "target <- seq_len(min(20, length(value)))\n",
                    "value <- value[target]\n",
                    "term <- term[target]\n",
                    "term <- sapply(term, function(x){substr(x, 1, 40)})\n\n",
                    "p <- plot_ly(x=term, y=~value,\n",
                    "type=\"bar\", color=~value, text=term,\n",
                    "colors=c(\"#4b61ba\", \"gray\", ",
                    "\"#a87963\", \"red\"))\n\n",
                    "layout(p, title=paste0(\"Pattern\", d),\n",
                    "margin = list(b = 250),\n",
                    "   xaxis=list(title=\"Term\", type = 'category',\n",
                    "     categoryorder = \"array\", categoryarray = term,\n",
                    "     tickangle = 45),\n",
                    "     yaxis=list(title=\"Value\"))\n",
                    "```\n\n" # Bottom
                ), collapse="")
            }, ""),
        collapse="")
    )
}

# 4. Session Information
.BODY4 <- paste0("\n\n# Session Information\n\n",
    "\n```{r, message=F, warning=F}\n",
    "sessionInfo()\n",
    "```\n")

# 5. License
.BODY5 <- paste0("\n\n# License\n\n",
    "Copyright (c) 2019 Koki Tsuyuzaki and Laboratory for ",
    "Bioinformatics Research, RIKEN Center for Biosystems Dynamics",
    " Reseach Released under the ",
    "[Artistic License 2.0](",
    "http://www.perlfoundation.org/artistic_license_2_0)\n")

library("testthat")
library("scTGIF")

options(testthat.use_colours = FALSE)

test_file("testthat/test_DistalLungEpithelium.R")
test_file("testthat/test_TGIFFunctions.R")
test_file("testthat/test_convertRowID.R")
test_file("testthat/test_cellMarkerToGmt.R")

## ----testdata, echo=TRUE, message=FALSE---------------------------------------
library("scTGIF")
library("SingleCellExperiment")
library("GSEABase")
library("msigdbr")

data("DistalLungEpithelium")
data("pca.DistalLungEpithelium")
data("label.DistalLungEpithelium")

## ----testdata2, echo=TRUE, fig.width=7, fig.height=7--------------------------
par(ask=FALSE)
plot(pca.DistalLungEpithelium, col=label.DistalLungEpithelium, pch=16,
    main="Distal lung epithelium dataset", xlab="PCA1", ylab="PCA2", bty="n")
text(0.1, 0.05, "AT1", col="#FF7F00", cex=2)
text(0.07, -0.15, "AT2", col="#E41A1C", cex=2)
text(0.13, -0.04, "BP", col="#A65628", cex=2)
text(0.125, -0.15, "Clara", col="#377EB8", cex=2)
text(0.09, -0.2, "Cilliated", col="#4DAF4A", cex=2)

## ----gmt, echo=TRUE-----------------------------------------------------------
m_df = msigdbr(species = "Mus musculus",
    category = "H")[, c("gs_name", "entrez_gene")]

hallmark = unique(m_df$gs_name)
gsc <- lapply(hallmark, function(h){
    target = which(m_df$gs_name == h)
    geneIds = unique(as.character(m_df$entrez_gene[target]))
    GeneSet(setName=h, geneIds)
})
gmt = GeneSetCollection(gsc)
gmt = gmt[1:10] # Reduced for this demo

## ----setting, echo=TRUE-------------------------------------------------------
sce <- SingleCellExperiment(assays = list(counts = DistalLungEpithelium))
reducedDims(sce) <- SimpleList(PCA=pca.DistalLungEpithelium)

## ----setting2, echo=TRUE------------------------------------------------------
CPMED <- function(input){
    libsize <- colSums(input)
    median(libsize) * t(t(input) / libsize)
}
normcounts(sce) <- log10(CPMED(counts(sce)) + 1)

## ----setting3, echo=TRUE------------------------------------------------------
settingTGIF(sce, gmt, reducedDimNames="PCA", assayNames="normcounts")

## ----calc, echo=TRUE----------------------------------------------------------
calcTGIF(sce, ndim=3)

## ----report, echo=TRUE--------------------------------------------------------
reportTGIF(sce,
    html.open=FALSE,
    title="scTGIF Report for DistalLungEpithelium dataset",
    author="Koki Tsuyuzaki")

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

.vapply_pb <- function(X, FUN, ...)
{
  env <- environment()
  pb_Total <- length(X)
  counter <- 0
  pb <- txtProgressBar(min = 0, max = pb_Total, style = 3)

  wrapper <- function(...){
    curVal <- get("counter", envir = env)
    assign("counter", curVal +1 ,envir=env)
    setTxtProgressBar(get("pb", envir=env), curVal +1)
    FUN(...)
  }
  res <- vapply(X, wrapper, ...)
  close(pb)
  res
}

.aggr.by.sum <- function(input, rowID, LtoR, score, unique.right){
    .aggr.by.xxx(input, rowID, LtoR, score, unique.right, "sum")
}

.aggr.by.mean <- function(input, rowID, LtoR, score, unique.right){
    .aggr.by.xxx(input, rowID, LtoR, score, unique.right, "mean")
}

.aggr.by.xxx <- function(input, rowID, LtoR, score, unique.right, ftype){
    vval <- list(input=input, rowID=rowID,
        LtoR=LtoR, score=score, ftype=ftype)
    out <- t(.vapply_pb(unique.right, function(x, vval){
        f <- vval$f
        input <- vval$input
        rowID <- vval$rowID
        LtoR <- vval$LtoR
        score <- vval$score
        ftype <- vval$ftype
        .each_x(input, rowID, LtoR, score, x, ftype)
    }, vval=vval, list(1.0*input[1,], c("", ""))))
    output <- matrix(unlist(out[,1]), ncol=length(input[1,]), byrow=TRUE)
    ctable <- matrix(unlist(out[,2]), ncol=2, byrow=TRUE)
    list(output=output, ctable=ctable)
}

.each_x <- function(input, rowID, LtoR, score, x, ftype){
    position <- which(LtoR[,2] == x)
    position2 <- sapply(LtoR[position, 1], function(x){which(rowID == x)})
    if(length(position2) == 1){
        left <- rowID[position2]
        out <- input[position2, ]
    }else{
        left <- paste0(rowID[position2], collapse=" / ")
        out <- .flist2[[ftype]](input[position2, ])
    }
    right <- x
    list(out, c(left, right))
}

.aggr.by.score <- function(input, rowID, LtoR, score, unique.right){
    bp <- graph.data.frame(LtoR, directed=FALSE)
    V(bp)$type <- c(rep(TRUE, length(unique(LtoR[,1]))),
        rep(FALSE, length(unique(LtoR[,2]))))
    E(bp)$weight <- score
    tmp <- na.omit(max_bipartite_match(bp)$matching)
    tmp <- tmp[seq(length(tmp)/2)]
    left <- names(tmp)
    right <- as.character(tmp)
    ctable <- cbind(left, right)
    output <- input[sapply(left, function(x){
        which(rowID == x)
    }), ]
    list(output=output, ctable=ctable)
}

.flist <- list(
    "sum" = .aggr.by.sum,
    "mean" = .aggr.by.mean,
    "large.mean" = .aggr.by.score,
    "large.var" = .aggr.by.score,
    "large.cv2" = .aggr.by.score
)

.flist2 <- list(
    "sum" = colSums,
    "mean" = colMeans
)

.score <- function(input, aggr.rule){
    if(aggr.rule %in% c("sum", "mean")){
        NULL
    }else{
        if(aggr.rule == "large.mean"){
            score <- apply(input, 1, sum)
        }
        if(aggr.rule == "large.var"){
            score <- apply(input, 1, var)
        }
        if(aggr.rule == "large.cv2"){
            score <- apply(input, 1, function(x){sd(x) / mean(x)})
        }
        score[which(is.nan(score))] <- -1E+50
        score[which(is.na(score))] <- -1E+50
        score[which(is.infinite(score))] <- -1E+50
        score
    }
}

convertRowID <- function(input, rowID, LtoR,
    aggr.rule=c("sum", "mean", "large.mean", "large.var", "large.cv2")){
    # Argument check
    aggr.rule = match.arg(aggr.rule)
    if(dim(input)[1] != length(rowID)){
        stop("The number of rows of input and the length of rowID must be same.")
    }
    LtoR <- LtoR[which(!is.na(LtoR[,1])), ]
    LtoR <- LtoR[which(!is.na(LtoR[,2])), ]
    target <- unlist(sapply(intersect(LtoR[,1], rowID), function(x){
            which(LtoR[,1] == x)}))
    LtoR <- LtoR[target, ]
    if(nrow(LtoR) == 0){
        stop("There is no common with rowID and LtoR.")
    }else{
        position <- sapply(intersect(LtoR[,1], rowID), function(x){
            which(rowID == x)[1]})
        input <- input[position, ]
        rowID <- rowID[position]
    }
    score <- .score(input, aggr.rule)

    # Mapping
    unique.right <- as.character(unique(LtoR[, 2]))
    f <- .flist[[aggr.rule]]
    out <- f(input, rowID, LtoR, score, unique.right)
    output <- out$output
    ctable <- out$ctable
    colnames(ctable) <- c("Left", "Right")
    colnames(output) <- colnames(input)
    rownames(output) <- ctable[,2]

    # Output
    message("Input matrix: ", nrow(input), "x", ncol(input))
    message("Output matrix: ", nrow(output), "x", ncol(output))
    if(aggr.rule %in% c("sum", "mean")){
        message("Some gene expression vectors were collapsed into single vector")
        message("  by ", aggr.rule, " rule")
    }
    if(aggr.rule %in% c("large.mean", "large.var", "large.cv2")){
        message("Single gene expression vector was selected from some vectors")
        message("  by ", aggr.rule, " rule")
        dif <- nrow(input) - nrow(output)
        if(dif > 0){
            message(paste0(dif, " of genes are removed from input matrix (",
                nrow(input), "x", ncol(input), "), ",
                "and ", nrow(output), " of genes are selected."))
        }
    }
    list(output=output, ctable=ctable)
}

context("convertRowID")

#
# Case1 : 1 vs 1
#
input <- matrix(1:20, nrow=4, ncol=5)
rowID <- c("A", "B", "C", "D")
LtoR <- rbind(
  c("A", "3"),
  c("B", "2"),
  c("C", "4"),
  c("D", "7"))

out <- convertRowID(input, rowID, LtoR, "sum")
expect_true(identical(rownames(out$output), LtoR[,2]))

out <- convertRowID(input, rowID, LtoR, "mean")
expect_true(identical(rownames(out$output), LtoR[,2]))

out <- convertRowID(input, rowID, LtoR, "large.mean")
expect_true(identical(rownames(out$output), LtoR[,2]))

out <- convertRowID(input, rowID, LtoR, "large.var")
expect_true(identical(rownames(out$output), LtoR[,2]))

out <- convertRowID(input, rowID, LtoR, "large.cv2")
expect_true(identical(rownames(out$output), LtoR[,2]))

# Answer
#   [,1] [,2] [,3] [,4] [,5]
# 3    1    5    9   13   17
# 2    2    6   10   14   18
# 4    3    7   11   15   19
# 7    4    8   12   16   20


# Case2 : 1 vs Many
input <- matrix(1:20, nrow=4, ncol=5)
rowID <- c("A", "B", "C", "D")
LtoR <- rbind(
  c("A", "3"),
  c("B", "2"), # If cannot decide which element should select, the first one is selected
  c("B", "6"),
  c("C", "4"),
  c("D", "7"))

out <- convertRowID(input, rowID, LtoR, "sum")
expect_true(identical(rownames(out$output), c("3", "2", "4", "7")))

out <- convertRowID(input, rowID, LtoR, "mean")
expect_true(identical(rownames(out$output), c("3", "2", "4", "7")))

out <- convertRowID(input, rowID, LtoR, "large.mean")
expect_true(identical(rownames(out$output), c("3", "2", "4", "7")))

out <- convertRowID(input, rowID, LtoR, "large.var")
expect_true(identical(rownames(out$output), c("3", "2", "4", "7")))

out <- convertRowID(input, rowID, LtoR, "large.cv2")
expect_true(identical(rownames(out$output), c("3", "2", "4", "7")))

# Answer
#   [,1] [,2] [,3] [,4] [,5]
# 3    1    5    9   13   17
# 2    2    6   10   14   18
# 4    3    7   11   15   19
# 7    4    8   12   16   20


# Case3 : Many vs 1
input <- matrix(1:20, nrow=4, ncol=5)
rowID <- c("A", "A", "B", "D")
LtoR <- rbind(
  c("A", "3"),
  c("B", "2"),
  c("C", "4"),
  c("D", "7"))

out <- convertRowID(input, rowID, LtoR, "sum")
expect_true(identical(rownames(out$output), c("3", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "mean")
expect_true(identical(rownames(out$output), c("3", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "large.mean")
expect_true(identical(rownames(out$output), c("3", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "large.var")
expect_true(identical(rownames(out$output), c("3", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "large.cv2")
expect_true(identical(rownames(out$output), c("3", "2", "7")))

# Answer
#   [,1] [,2] [,3] [,4] [,5]
# 3    1    5    9   13   17
# 2    3    7   11   15   19
# 7    4    8   12   16   20


# Case4 : Many vs Many
input <- matrix(1:20, nrow=4, ncol=5)
rowID <- c("A", "A", "B", "D")
LtoR <- rbind(
  c("A", "5"),
  c("B", "2"), # If cannot decide which element should select, the first one is selected
  c("B", "6"),
  c("C", "4"),
  c("D", "7"))

out <- convertRowID(input, rowID, LtoR, "sum")
expect_true(identical(rownames(out$output), c("5", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "mean")
expect_true(identical(rownames(out$output), c("5", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "large.mean")
expect_true(identical(rownames(out$output), c("5", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "large.var")
expect_true(identical(rownames(out$output), c("5", "2", "7")))

out <- convertRowID(input, rowID, LtoR, "large.cv2")
expect_true(identical(rownames(out$output), c("5", "2", "7")))

# Answer
#   [,1] [,2] [,3] [,4] [,5]
# 5    1    5    9   13   17
# 2    3    7   11   15   19
# 7    4    8   12   16   20

cellMarkerToGmt <- function(infile, outfile,
  uniq.column=c("tissueType", "cellName"),
  geneid.type=c("geneID", "geneSymbol")){
    # Argument Check
    uniq.column = match.arg(uniq.column)
    geneid.type = match.arg(geneid.type)
    # Load
    cm <- read.delim(infile, stringsAsFactors=FALSE)
    uniq.term <- unique(cm[, uniq.column])
    # Parse
    out <- sapply(uniq.term, function(left, cm){
      right <- cm[which(cm[, uniq.column] == left), geneid.type]
      right <- paste(right, collapse=", ")
      right <- na.omit(strsplit(right, ", ")[[1]])
      right <- right[!right %in% "NA"]
      if(geneid.type == "geneID"){
        right[grep("^[0-9]", right)]
      }else{
        right[grep("^[0-9]", right, invert = TRUE)]
      }
    }, cm=cm)
    # Save
    sink(outfile)
    for(j in seq_len(length(out))){
      cat(paste0(c(names(out)[j], "na", out[[j]]), collapse="\t"))
      cat("\n")
    }
    sink()
}

context("cellMarkerToGmt")

library("GSEABase")

tmp <- tempdir()
infile1 = paste0(tmp, "/Human_cell_markers.txt")
infile2 = paste0(tmp, "/Mouse_cell_markers.txt")
infile3 = paste0(tmp, "/Single_cell_markers.txt")
infile4 = paste0(tmp, "/all_cell_markers.txt")

outfile1_1 = paste0(tmp, "/Human_cell_markers_1.gmt")
outfile1_2 = paste0(tmp, "/Human_cell_markers_2.gmt")
outfile1_3 = paste0(tmp, "/Human_cell_markers_3.gmt")
outfile1_4 = paste0(tmp, "/Human_cell_markers_4.gmt")
outfile2_1 = paste0(tmp, "/Mouse_cell_markers_1.gmt")
outfile2_2 = paste0(tmp, "/Mouse_cell_markers_2.gmt")
outfile2_3 = paste0(tmp, "/Mouse_cell_markers_3.gmt")
outfile2_4 = paste0(tmp, "/Mouse_cell_markers_4.gmt")
outfile3_1 = paste0(tmp, "/Single_cell_markers_1.gmt")
outfile3_2 = paste0(tmp, "/Single_cell_markers_2.gmt")
outfile3_3 = paste0(tmp, "/Single_cell_markers_3.gmt")
outfile3_4 = paste0(tmp, "/Single_cell_markers_4.gmt")
outfile4_1 = paste0(tmp, "/all_cell_markers_1.gmt")
outfile4_2 = paste0(tmp, "/all_cell_markers_2.gmt")
outfile4_3 = paste0(tmp, "/all_cell_markers_3.gmt")
outfile4_4 = paste0(tmp, "/all_cell_markers_4.gmt")

# Human_cell_markers.txt
sink(infile1)
cat("speciesType\ttissueType\tUberonOntologyID\tcancerType\tcellType\tcellName\tCellOntologyID\tcellMarker\tgeneSymbol\tgeneID\tproteinName\tproteinID\tmarkerResource\tPMID\tCompany\n")
cat("Human\tKidney\tUBERON_0002113\tNormal\tNormal cell\tProximal tubular cell\tNA\tIntestinal Alkaline Phosphatase\tALPI\t248\tPPBI\tP09923\tExperiment\t9263997\tNA\n")
cat("Human\tLiver\tUBERON_0002107\tNormal\tNormal cell\tIto cell (hepatic stellate cell)\tCL_0000632\tSynaptophysin\tSYP\t6855\tSYPH\tP08247\tExperiment\t10595912\tNA\n")
cat("Human\tEndometrium\tUBERON_0001295\tNormal\tNormal cell\tTrophoblast cell\tCL_0000351\tCEACAM1\tCEACAM1\t634\tCEAM1\tP13688\tExperiment\t10751340\tNA\n")
cat("Human\tGerm\tUBERON_0000923\tNormal\tNormal cell\tPrimordial germ cell\tCL_0000670\tVASA\tDDX4\t54514\tDDX4\tQ9NQI0\tExperiment\t10920202\tNA\n")
cat("Human\tCorneal epithelium\tUBERON_0001772\tNormal\tNormal cell\tEpithelial cell\tCL_0000066\tKLF6\tKLF6\t1316\tKLF6\tQ99612\tExperiment\t12407152\tNA\n")
cat("Human\tPlacenta\tUBERON_0001987\tNormal\tNormal cell\tCytotrophoblast\tCL_0000351\tFGF10\tFGF10\t2255\tFGF10\tO15520\tExperiment\t15950061\tNA\n")
cat("Human\tPeriosteum\tUBERON_0002515\tNormal\tNormal cell\tPeriosteum-derived progenitor cell\tNA\tCD166, CD45, CD9, CD90\tALCAM, PTPRC, CD9, THY1\t214, 5788, 928, 7070\tCD166, PTPRC, CD9, THY1\tQ13740, P08575, P21926, P04216\tExperiment\t15977065\tNA\n")
cat("Human\tAmniotic membrane\tUBERON_0009742\tNormal\tNormal cell\tAmnion epithelial cell\tCL_0002536\tNANOG, OCT3/4\tNANOG, POU5F1\t79923, 5460\tNANOG, PO5F1\tQ9H9S0, Q01860\tExperiment\t16081662\tNA\n")
cat("Human\tPrimitive streak\tUBERON_0004341\tNormal\tNormal cell\tPrimitive streak cell\tNA\tLHX1, MIXL1\tLHX1, MIXL1\t3975, 83881\tLHX1, MIXL1\tP48742, Q9H2W2\tExperiment\t16258519\tNA\n")
sink()

# Mouse_cell_markers.txt
sink(infile2)
cat("speciesType\ttissueType\tUberonOntologyID\tcancerType\tcellType\tcellName\tCellOntologyID\tcellMarker\tgeneSymbol\tgeneID\tproteinName\tproteinID\tmarkerResource\tPMID\tCompany\n")
cat("Mouse\tBone marrow\tUBERON_0002371\tNormal\tNormal cell\tBlastema cell\tCL_0000354\tCD31, Sca-1, Vim\tPecam1, Ly6a, Vim\t18613, 110454, 22352\tPECA1, LY6A, VIME\tQ08481, P05533, P20152\tExperiment\t29105393\tNA\n")
cat("Mouse\tTaste bud\tUBERON_0001727\tNormal\tNormal cell\tType II taste bud cell\tCL_0002285\tGustducin, PLC beta2\tPlcb2, Gnat3\t18796, 242851\tGNAT3, PLCB2\tA3KGF7, Q3V3I2\tExperiment\t29525940NA\n")
cat("Mouse\tTaste bud\tUBERON_0001727\tNormal\tNormal cell\tType III taste bud cell\tCL_0002285\tAADC, CA4, GAD67, NCAM, SNAP25\tDdc, Car4, Gad1, Ncam1, Snap25\t13195, 12351, 14451, 17967, 20614\tDDC, CAH4, DCE1, NCAM1, SNP25\tO88533, P22748, P48318, P13595, P60879\tExperiment\t29525940\tNA\n")
cat("Mouse\tAdipose tissue\tUBERON_0001013\tNormal\tNormal cell\tAdipose-derived stem cell\tCL_0000034\tSca-1\tLy6a\t110454\tLY6A\tP05533\tExperiment\t24726953\tNA\n")
cat("Mouse\tUndefined\tNA\tNormal\tNormal cell\tRegulatory T (Treg) cell\tCL_0000815\tCD49b, LAG3\tItga2, Lag3\t16398, 16768\tITA2, LAG3\tQ62469, P18627\tExperiment\t28929191\tNA\n")
cat("Mouse\tAdipose tissue\tUBERON_0001013\tNormal\tNormal cell\tWhite fat cell\tCL_0000448\tAsc-1\tSlc7a10\t53896\tAAA1\tP63115\tExperiment\t25080478\tNA\n")
cat("Mouse\tMeniscus\tUBERON_0000387\tNormal\tNormal cell\tMeniscus-derived stem cell\tNA\tCD105, CD34, CD44, CD73, CD90, Sca-1\tEng, Cd34, Cd44, Nt5e, Thy1, Ly6a\t13805, 12490, 12505, 23959, 21838, 110454\tEGLN, CD34, CD44, 5NTD, THY1, LY6A\tQ63961, Q64314, P15379, Q61503, P01831, P05533\tExperiment\t28005443\tNA\n")
cat("Mouse\tMeniscus\tUBERON_0000387\tNormal\tNormal cell\tMeniscus-derived progenitor cell\tNA\tCD105, CD34, CD44, CD73, CD90, Sca-1\tEng, Cd34, Cd44, Nt5e, Thy1, Ly6a\t13805, 12490, 12505, 23959, 21838, 110454\tEGLN, CD34, CD44, 5NTD, THY1, LY6A\tQ63961, Q64314, P15379, Q61503, P01831, P05533\tExperiment\t28005443\tNA\n")
cat("Mouse\tPeyer patch\tUBERON_0001211\tNormal\tNormal cell\tB cell\tCL_0000236\tCD45R\tPtprc\t19264\tPTPRC\tP06800\tExperiment\t24182520\tNA\n")
sink()

# Single_cell_markers.txt
sink(infile3)
cat("speciesType\ttissueType\tUberonOntologyID\tcancerType\tcellType\tcellName\tCellOntologyID\tcellMarker\tgeneSymbol\tgeneID\tproteinName\tproteinID\tmarkerResource\tPMID\tCompany\n")
cat("Human\tLung\tUBERON_0002048\tNormal\tNormal cell\tType II pneumocyte\tCL_0002063\tABCA3, SLC34A2\tABCA3, SLC34A2\t21, 10568\tABCA3, NPT2B\tQ99758, O95436\tSingle-cell sequencing\t27942595\tNA\n")
cat("Human\tLung\tUBERON_0002048\tNormal\tNormal cell\tAirway secretory cell\tCL_1000272\tAQP3, MUC5AC, MUC5B, PIGR, SCGB1A1\tAQP3, MUC5AC, MUC5B, PIGR, SCGB1A1\t360, 4586, 727897, 5284, 7356\tAQP3, MUC5A, MUC5B, PIGR, UTER\tQ92482, P98088, Q9HC84, P01833, P11684\tSingle-cell sequencing\t27942595\tNA\n")
cat("Human\tPancreas\tUBERON_0001264\tNormal\tNormal cell\tAlpha cell\tCL_0000171\tARX, CLIM1, CRYBA2, FEV, GBA, HMGB3, ILTMP, IRX2, KRP1, LOXL4, MAFB, PGE2-R, PGR, PLCE1, RFX6, RGP4, SMARCA1\tUBA2, LDB2, CRYBA2, FEV, GBA, HMGB3, TM4SF4, IRX2, KLHL41, LOXL4, MAFB, PTGER3, PGR, PLCE1, RFX6, RGPD4, SMARCA1\t10054, 9079, 1412, 54738, 2629, 3149, 7104, 153572, 10324, 84171, 9935, 5733, 5241, 51196, 222546, 285190, 6594\tARX, PDLI1, CRBA2, FEV, GLCM, HMGB3, T4S4, IRX2, KLH41, LOXL4, MAFB, PE2R3, PRGR, PLCE1, RFX6, RGS4, SMCA1\tQ96QS3, O00151, P53672, Q99581, P04062, O15347, P48230, Q9BZI1, O60662, Q96JB6, Q9Y5Q3, P43115, P06401, Q9P212, Q8HWS3, P49798, P28370\tSingle-cell sequencing\t27693023\tNA\n")
cat("Human\tPancreas\tUBERON_0001264\tNormal\tNormal cell\tBeta cellCL_0000169\tBMP-5, CDKN1C, CRTR1, DLK1, NPTX2, PACAP, PDX1, PFKFB2, PIR, SIX2, SIX3, SMAD9, SYT13, TGFBR3\tBMP5, CDKN1C, TFCP2L1, DLK1, NPTX2, MZB1, PDX1, PFKFB2, PIR, SIX2, SIX3, SMAD9, SYT13, TGFBR3\t653, 1028, 29842, 8788, 4885, 51237, 3651, 5208, 8544, 10736, 6496, 4093, 57586, 7049\tBMP5, CDN1C, TF2L1, DLK1, NPTX2, PACA, ODPX, F262, PIR, SIX2, SIX3, SMAD9, SYT13, TGBR3\tP22003, P49918, Q9NZI6, P80370, P47972, P18509, O00330, O60825, O00625, Q9NPC8, O95343, O15198, Q7L8C5, Q03167\tSingle-cell sequencing\t27693023\tNA\n")
cat("Human\tPancreas\tUBERON_0001264\tNormal\tNormal cell\tDelta cell\tCL_0000173\tCHE1, ESE3B, ETV1, GABRG2, HER4, ISL1, LCORL, LEDGF, LEPR, NEC1, PDLIM4, POU3F1, PRBP, PRG4, RGS2, SFRP3, SHARP1\tAATF, EHF, ETV1, GABRG2, ERBB4, ISL1, LCORL, PSIP1, LEPROT, PCSK1, PDLIM4, POU3F1, RBP4, PRG4, RGS2, FRZB, BHLHE41\t26574, 26298, 2115, 2566, 2066, 3670, 254251, 11168, 54741, 5122, 8572, 5453, 5950, 10216, 5997, 2487, 79365\tAATF, EHF, ETV1, GBRG2, ERBB4, ISL1, LCORL, PSIP1, LEPR, NEC1, PDLI4, PO3F1, RET4, PLPR2, RGS2, SFRP3, BHE41\tQ9NY61, Q9NZC4, P50549, P18507, Q15303, P61371, Q8N3X6, O75475, P48357, P29120, P50479, Q03052, P02753, Q96GM1, P41220, Q92765, Q9C0J9\tSingle-cell sequencing\t27693023NA\n")
cat("Human\tPancreas\tUBERON_0001264\tNormal\tNormal cell\tPancreatic polypeptide cell\tCL_0002275\tAQP3, ARHGAP3, ARX, BHLHB26, BHLHB27, CARTPT, EGR3, ENTPD2, ETV1, MEIS1, MEIS2, PAX6, PTGFR, RBTN3, SERTM1, SLITRK6, THSD7A, ZNF506\tAQP3, CHN2, UBA2, ID2, ID4, CARTPT, EGR3, ENTPD2, ETV1, MEIS1, MEIS2, PAX6, PTGFR, LMO3, SERTM1, SLITRK6, THSD7A, ZNF506\t360, 1124, 10054, 3398, 3400, 9607, 1960, 954, 2115, 4211, 4212, 5080, 5737, 55885, 400120, 84189, 221981, 440515\tAQP3, CHIO, ARX, ID2, ID4, CART, EGR3, ENTP2, ETV1, MEIS1, MEIS2, PAX6, PF2R, LMO3, SRTM1, SLIK6, THS7A, ZN506\tQ92482, P52757, Q96QS3, Q02363, P47928, Q16568, Q06889, Q9Y5L3, P50549, O00470, O14770, P26367, P43088, Q8TAP4, A2A2V5, Q9H5Y7, Q9UPZ6, Q5JVG8\tSingle-cell sequencing\t27693023\tNA\n")
cat("Human\tBrain\tUBERON_0000955\tNormal\tNormal cell\tAstrocyte\tCL_0000127\tGFAP\tGFAP\t2670\tGFAP\tP14136\tSingle-cell sequencing\t27587997\tNA\n")
cat("Human\tBrain\tUBERON_0000955\tNormal\tNormal cell\tNeuron\tCL_0000540\tENO2, SYP\tENO2, SYP\t2026, 6855\tENOG, SYPH\tP09104, P08247\tSingle-cell sequencing\t27587997\tNA\n")
cat("Human\tUndefined\tNA\tNormal\tNormal cell\tNeuronal progenitor cell\tNA\tMAP2, PAX6, SOX2\tMAP2, PAX6, SOX2\t4133, 5080, 6657\tMAP2, PAX6, SOX2\tP50579, P26367, P48431\tSingle-cell sequencing\t27534536\tNA\n")
sink()


# all_cell_markers.txt
sink(infile4)
cat("speciesType\ttissueType\tUberonOntologyID\tcancerType\tcellType\tcellName\tCellOntologyID\tcellMarker\tgeneSymbol\tgeneID\tproteinName\tproteinID\tmarkerResource\tPMID\tCompany\n")
cat("Human\tKidney\tUBERON_0002113\tNormal\tNormal cell\tProximal tubular cell\tNA\tIntestinal Alkaline Phosphatase\tALPI\t248\tPPBI\tP09923\tExperiment\t9263997\tNA\n")
cat("Human\tLiver\tUBERON_0002107\tNormal\tNormal cell\tIto cell (hepatic stellate cell)\tCL_0000632\tSynaptophysin\tSYP\t6855\tSYPH\tP08247\tExperiment\t10595912\tNA\n")
cat("Human\tEndometrium\tUBERON_0001295\tNormal\tNormal cell\tTrophoblast cell\tCL_0000351\tCEACAM1\tCEACAM1\t634\tCEAM1\tP13688\tExperiment\t10751340\tNA\n")
cat("Human\tGerm\tUBERON_0000923\tNormal\tNormal cell\tPrimordial germ cell\tCL_0000670\tVASA\tDDX4\t54514\tDDX4\tQ9NQI0\tExperiment\t10920202\tNA\n")
cat("Human\tCorneal epithelium\tUBERON_0001772\tNormal\tNormal cell\tEpithelial cell\tCL_0000066\tKLF6\tKLF6\t1316\tKLF6\tQ99612\tExperiment\t12407152\tNA\n")
cat("Human\tPlacenta\tUBERON_0001987\tNormal\tNormal cell\tCytotrophoblast\tCL_0000351\tFGF10\tFGF10\t2255\tFGF10\tO15520\tExperiment\t15950061\tNA\n")
cat("Human\tPeriosteum\tUBERON_0002515\tNormal\tNormal cell\tPeriosteum-derived progenitor cell\tNA\tCD166, CD45, CD9, CD90\tALCAM, PTPRC, CD9, THY1\t214, 5788, 928, 7070\tCD166, PTPRC, CD9, THY1\tQ13740, P08575, P21926, P04216\tExperiment\t15977065\tNA\n")
cat("Human\tAmniotic membrane\tUBERON_0009742\tNormal\tNormal cell\tAmnion epithelial cell\tCL_0002536\tNANOG, OCT3/4\tNANOG, POU5F1\t79923, 5460\tNANOG, PO5F1\tQ9H9S0, Q01860\tExperiment\t16081662NA\n")
cat("Human\tPrimitive streak\tUBERON_0004341\tNormal\tNormal cell\tPrimitive streak cell\tNA\tLHX1, MIXL1\tLHX1, MIXL1\t3975, 83881\tLHX1, MIXL1\tP48742, Q9H2W2\tExperiment\t16258519\tNA\n")
sink()


# Human_cell_markers.txt
cellMarkerToGmt(infile1, outfile1_1, uniq.column=c("tissueType"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile1, outfile1_2, uniq.column=c("tissueType"),
	geneid.type=c("geneSymbol"))
cellMarkerToGmt(infile1, outfile1_3, uniq.column=c("cellName"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile1, outfile1_4, uniq.column=c("cellName"),
	geneid.type=c("geneSymbol"))

# Mouse_cell_markers.txt
cellMarkerToGmt(infile2, outfile2_1, uniq.column=c("tissueType"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile2, outfile2_2, uniq.column=c("tissueType"),
	geneid.type=c("geneSymbol"))
cellMarkerToGmt(infile2, outfile2_3, uniq.column=c("cellName"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile2, outfile2_4, uniq.column=c("cellName"),
	geneid.type=c("geneSymbol"))

# Single_cell_markers.txt
cellMarkerToGmt(infile3, outfile3_1, uniq.column=c("tissueType"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile3, outfile3_2, uniq.column=c("tissueType"),
	geneid.type=c("geneSymbol"))
cellMarkerToGmt(infile3, outfile3_3, uniq.column=c("cellName"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile3, outfile3_4, uniq.column=c("cellName"),
	geneid.type=c("geneSymbol"))

# all_cell_markers.txt
cellMarkerToGmt(infile4, outfile4_1, uniq.column=c("tissueType"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile4, outfile4_2, uniq.column=c("tissueType"),
	geneid.type=c("geneSymbol"))
cellMarkerToGmt(infile4, outfile4_3, uniq.column=c("cellName"),
	geneid.type=c("geneID"))
cellMarkerToGmt(infile4, outfile4_4, uniq.column=c("cellName"),
	geneid.type=c("geneSymbol"))


# Human_cell_markers.txt
gmt1_1 <- getGmt(outfile1_1)
gmt1_2 <- getGmt(outfile1_2)
gmt1_3 <- getGmt(outfile1_3)
gmt1_4 <- getGmt(outfile1_4)

# Mouse_cell_markers.txt
gmt2_1 <- getGmt(outfile2_1)
gmt2_2 <- getGmt(outfile2_2)
gmt2_3 <- getGmt(outfile2_3)
gmt2_4 <- getGmt(outfile2_4)

# Single_cell_markers.txt
gmt3_1 <- getGmt(outfile3_1)
gmt3_2 <- getGmt(outfile3_2)
gmt3_3 <- getGmt(outfile3_3)
gmt3_4 <- getGmt(outfile3_4)

# all_cell_markers.txt
gmt4_1 <- getGmt(outfile4_1)
gmt4_2 <- getGmt(outfile4_2)
gmt4_3 <- getGmt(outfile4_3)
gmt4_4 <- getGmt(outfile4_4)

# Test
expect_true(length(gmt1_1) == 9)
expect_true(length(gmt1_2) == 9)
expect_true(length(gmt1_3) == 9)
expect_true(length(gmt1_4) == 9)

expect_true(length(gmt2_1) == 6)
expect_true(length(gmt2_2) == 6)
expect_true(length(gmt2_3) == 9)
expect_true(length(gmt2_4) == 9)

expect_true(length(gmt3_1) == 4)
expect_true(length(gmt3_2) == 4)
expect_true(length(gmt3_3) == 9)
expect_true(length(gmt3_4) == 9)

expect_true(length(gmt4_1) == 9)
expect_true(length(gmt4_2) == 9)
expect_true(length(gmt4_3) == 9)
expect_true(length(gmt4_4) == 9)

#
# settingTGIF
#
setGeneric("settingTGIF", function(sce, gmt, reducedDimNames,
    assayNames="counts", nbins=40){
    standardGeneric("settingTGIF")})

setMethod("settingTGIF",
    signature(sce="SingleCellExperiment"),
    function(sce, gmt, reducedDimNames, assayNames="counts", nbins=40){
        userobjects <- deparse(substitute(sce))
        .settingTGIF(userobjects, gmt, reducedDimNames, assayNames,
            nbins, sce)})

.settingTGIF <- function(userobjects, gmt, reducedDimNames, assayNames,
    nbins, ...){
    sce <- list(...)[[1]]
    # class-check
    classCheck <- class(gmt)
    if(classCheck != "GeneSetCollection"){
        stop(paste0("Please specify the gmt as GeneSetCollection object ",
            "defined by GSEABase package"))
    }
    # Rowname-check
    rn <- rownames(assay(sce))
    if(length(rn) != length(unique(rn))){
        stop("Please specify the row names of the input matrix is unique")
    }
    # Only matrix is accepted
    if(!is.matrix(assay(sce))){
        message("The input data is coverted to matrix format by as.matrix")
        assay(sce) <- as.matrix(assay(sce))
    }
    # Import expression matrix
    input <- .importAssays(sce, assayNames)
    # Low dimensional data
    twoD <- reducedDims(sce)[[reducedDimNames]]
    if(ncol(input) != nrow(twoD)){
        stop(paste0("The number of columns in assay(sce) ",
            "and the number of samples in ",
            paste0("reducedDims(sce)[['", reducedDimNames, "']]"),
            "must be same"))
    }
    # two dimensional coordinates
    data.geneid <- unique(rownames(input))
    gmt.geneid <- unique(unlist(lapply(gmt, function(g){
        geneIds(g)
    })))
    common.geneid <- intersect(data.geneid, gmt.geneid)
    if(length(common.geneid) == 0){
        stop(paste0("Please specify the rownames of assay(sce) and ",
            " gmt must be same and specified as NCBI (Entrez) Gene IDs"))
    }
    # Setting of schex
    sce <- make_hexbin(sce, nbins=nbins,
        dimension_reduction=reducedDimNames)
    # Gene * Bin matrix
    X <- .twoDimBin(sce, common.geneid, assayNames)
    # Gene * Function matrix
    Y <- .convertGMT(gmt, common.geneid)
    X[is.nan(X)] <- 0
    Y[is.nan(Y)] <- 0
    # Overwrite
    metadata(sce)[["gmt"]] <- gmt
    metadata(sce)[["X"]] <- X
    metadata(sce)[["Y"]] <- Y
    metadata(sce)[["common.geneid"]] <- common.geneid
    metadata(sce)[["nbins"]] <- nbins
    metadata(sce)[["reducedDimNames"]] <- reducedDimNames
    metadata(sce)[["assayNames"]] <- assayNames
    assign(userobjects, sce, envir=.GlobalEnv)
}

#
# calcTGIF
#
setGeneric("calcTGIF", function(sce, ndim, verbose=FALSE, droplet=TRUE){
    standardGeneric("calcTGIF")})

setMethod("calcTGIF",
    signature(sce="SingleCellExperiment"),
    function(sce, ndim, verbose=FALSE, droplet=TRUE){
        userobjects <- deparse(substitute(sce))
        .calcTGIF(userobjects, ndim, verbose, droplet, sce)})

.calcTGIF <- function(userobjects, ndim, verbose, droplet, ...){
    sce <- list(...)[[1]]
    # Import expression matrix
    assayNames <- metadata(sce)$assayNames
    input <- .importAssays(sce, assayNames)
    # ここで鬼QC!!!!!
    # QC <- .QCmetrics(sce, input, droplet)
    X <- metadata(sce)$X
    Y <- metadata(sce)$Y
    if(min(ncol(X), ncol(Y)) < ndim){
        stop(paste0("Please specify ndim parameter smaller than ",
            min(ncol(X), ncol(Y))))
    }
    cat(paste0("Gene x Grid matrix (X) has ", nrow(X), " rows and ",
        ncol(X), " columns\n"))
    cat(paste0("Gene x Function matrix (Y) has ", nrow(Y), " rows and ",
        ncol(Y), " columns\n"))
    # Joint NMF
    res.sctgif <- jNMF(list(X=X, Y=Y), J=ndim, algorithm="Frobenius",
        verbose=verbose)
    # Reconstruction error
    recerror <- res.sctgif$RecError
    relchange <- res.sctgif$RelChange
    # Overwrite
    # metadata(sce)[["QC"]] <- QC
    metadata(sce)[["sctgif"]] <- res.sctgif
    metadata(sce)[["ndim"]] <- ndim
    metadata(sce)[["recerror"]] <- recerror
    metadata(sce)[["relchange"]] <- relchange
    assign(userobjects, sce, envir=.GlobalEnv)
}

#
# reportTGIF
#
setGeneric("reportTGIF", function(sce, out.dir=tempdir(), html.open=FALSE,
    title="The result of scTGIF",
    author="The person who runs this script",
    assayNames="counts"){
    standardGeneric("reportTGIF")})

setMethod("reportTGIF",
    signature(sce="SingleCellExperiment"),
    function(sce, out.dir=tempdir(), html.open=FALSE,
    title="The result of scTGIF",
    author="The person who runs this script",
    assayNames="counts"){
        .reportTGIF(out.dir, html.open, title, author, assayNames, sce)})

.reportTGIF <- function(out.dir, html.open, title, author, assayNames, ...){
    sce <- list(...)[[1]]
    if(is.null(metadata(sce)$sctgif)){
        stop("scTGIF did not performed properly")
    }
    # The Directory for saving the analytical result
    dir.create(paste0(out.dir, "/figures"),
        showWarnings = FALSE, recursive = TRUE)
    # File copy
    file.copy(from = system.file("extdata", "Workflow.png",
        package = "scTGIF"), to = paste0(out.dir, "/Workflow.png"),
        overwrite = TRUE)

    # Grid * Dim
    H1 <- metadata(sce)$sctgif$H[[1]]
    norm.H1 <- apply(H1, 2, function(x){norm(as.matrix(x), "F")})
    H1 <- t(t(H1) / norm.H1)
    # Function * Dim
    H2 <- metadata(sce)$sctgif$H[[2]]
    norm.H2 <- apply(H2, 2, function(x){norm(as.matrix(x), "F")})
    H2 <- t(t(H2) / norm.H2)
    # Sort
    corevalue <- norm.H1 * norm.H2
    H1 <- H1[, order(corevalue, decreasing=TRUE)]
    H2 <- H2[, order(corevalue, decreasing=TRUE)]
    corevalue <- corevalue[order(corevalue, decreasing=TRUE)]
    # Import expression matrix
    input <- .importAssays(sce, assayNames)
    # From metadata
    gmt <- metadata(sce)$gmt
    X <- metadata(sce)$X
    Y <- metadata(sce)$Y
    common.geneid <- metadata(sce)$common.geneid
    nbins <- metadata(sce)$nbins
    reducedDimNames <- metadata(sce)$reducedDimNames
    sctgif <- metadata(sce)$sctgif
    ndim <- metadata(sce)$ndim
    recerror <- metadata(sce)$recerror
    relchange <- metadata(sce)$relchange

    # Low dimensional data
    twoD <- reducedDims(sce)[[reducedDimNames]]

    # Plot
    for(i in seq_len(ncol(H1))){
        filename <- paste0(out.dir, "/figures/Hex_", i, ".png")
        g <- .plot_hexbin_pattern(sce, H1[, i], i)
        ggsave(filename, plot=g, dpi=200, width=6, height=6.5)
        system(paste0("ls ", filename))
    }

    # Save the result of scTGIF
    save(sce, input, twoD, H1, H2, corevalue,
        file=paste0(out.dir, "/reanalysis.RData"))

    # Output index.html
    message("index.Rmd is created...")
    outIdx <- file(paste0(out.dir, "/index.Rmd"), "w")
    writeLines(.HEADER(author, title), outIdx, sep="\n")
    writeLines(.BODY1, outIdx, sep="\n")
    writeLines(.BODY2, outIdx, sep="\n")
    writeLines(.BODY3(ndim, out.dir), outIdx, sep="\n")
    writeLines(.BODY4, outIdx, sep="\n")
    writeLines(.BODY5, outIdx, sep="\n")
    close(outIdx)

    # Rendering
    message("index.Rmd is compiled to index.html...")
    render(paste0(out.dir, "/index.Rmd"), quiet=TRUE)
    # HTML Open
    message(paste0("################################################\n",
        "Data files are saved in\n",
        out.dir, "\n################################################\n"))
    if (html.open) {
        browseURL(paste0(out.dir, "/index.html"))
    }
}

context("TGIFFunctions")

# Package loading
library("SingleCellExperiment")

# Data loading
data("DistalLungEpithelium")
data("pca.DistalLungEpithelium")
data("label.DistalLungEpithelium")

# SingleCellExperiment-class
sce <- SingleCellExperiment(assays = list(counts = DistalLungEpithelium))
reducedDims(sce) <- SimpleList(PCA=pca.DistalLungEpithelium)

# Generic
expect_true("genericFunction" %in% is(settingTGIF))
expect_true("genericFunction" %in% is(calcTGIF))
expect_true("genericFunction" %in% is(reportTGIF))

context("DistalLungEpithelium")

data("DistalLungEpithelium")
expect_true(nrow(DistalLungEpithelium) == 3397)
expect_true(ncol(DistalLungEpithelium) == 80)

data("pca.DistalLungEpithelium")
expect_true(nrow(pca.DistalLungEpithelium) == 80)
expect_true(ncol(pca.DistalLungEpithelium) == 2)

data("label.DistalLungEpithelium")
expect_true(length(label.DistalLungEpithelium) == 80)

---
title: "Annotation for unannotated single-cell RNA-Seq data by `scTGIF`"
author:
- name: Koki Tsuyuzaki
  affiliation: Laboratory for Bioinformatics Research,
      RIKEN Center for Biosystems Dynamics Reseach
- name: Itoshi Nikaido
  affiliation: Laboratory for Bioinformatics Research,
      RIKEN Center for Biosystems Dynamics Reseach
  email: k.t.the-answer@hotmail.co.jp
package: scTGIF
output:
    BiocStyle::html_document
vignette: |
    %\VignetteIndexEntry{scTGIF}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction
## About scTGIF

Here, we explain the concept of `r Biocpkg("scTGIF")`.
The analysis of single-cell RNA-Seq (scRNA-Seq) has a
potential difficult problem; which data corresponds to what kind of
cell type is not known _a priori_.

Therefore, at the start point of the data analysis of the scRNA-Seq dataset,
each cell is "not colored" (unannotated) (Figure 1).
There some approaches to support users to infer the cell types
such as (1) Known marker gene expression,
(2) BLAST-like gene expression comparison with reference DB,
(3) differentially expressed genes (DEGs)
and over-representative analysis (ORA)
([scRNA-tools](https://www.scrna-tools.org)).

The first approach might be the most popular method,
but this task is based on the expert knowledge about the cell types,
and not always general-purpose.
The second approach is easy and scalable,
but still limited when the cell type is not known
or still not measured by the other research organization.
The third approach can perhaps be used in any situation but ambiguous and
time-consuming task;
this task is based on the cluster label and the true cluster structure,
which is not known and some DEG methods have to be performed in each cluster,
but recent scRNA-Seq dataset has tens to hundreds of cell types.
Besides, a scRNA-Seq dataset can have low-quality cells and artifacts
(e.g. doublet) but it is hard to distinguish from real cell data.
Therefore, in actual data analytical situation, laborious
trial-and-error cycle along with the change of cellular label
cannot be evitable (Figure 1).

`r Biocpkg("scTGIF")` is developed to reduce this trial-and-error cycle;
This tool directly connects the unannotated cells and
related gene function.
Since this tool does not use reference DB, marker gene list,
and cluster label can be used in any situation without expert knowledge
and is not influenced by the change of cellular label.

![Figure 1: Concept of scTGIF](TrialandError.png)

In `r Biocpkg("scTGIF")`, three data is required; the gene expression matrix,
2D coordinates of the cells (e.g. t-SNE, UMAP), and geneset of MSigDB.
Firstly, the 2D coordinates are segmented as 50-by-50 grids,
and gene expression is summarized in each grid level (**X1**).
Next, the correspondence between genes and the related gene functions
are summarized as gene-by-function matrix (**X2**).
Here, we support only common genes are used in **X1** and **X2**.
Performing joint non-negative matrix factorization (jNMF) algorithm,
which is implemented in `r CRANpkg("nnTensor")`,
the shared latent variables (**W**) with the two matrices are estimated.

![Figure 2: Joint NMF](jNMF.png)

By this algorithm, a grid set and corresponding gene functions are paired.
Lower-dimension (**D**)-by-Grid matrix **H1** works as attention maps to help
users to pay attention the grids, and **D**-by-Function matrix **H2**
shows the gene function enriched in the grids.

![Figure 3: H1 and H2 matrices](H1_H2.png)

`r Biocpkg("scTGIF")` also supports some QC metrics to distinguish
low-quality cells and artifacts from real cellular data.

# Usage
### Test data

To demonstrate the usage of `r Biocpkg("scTGIF")`,
we prepared a testdata of
[distal lung epithelium](https://www.nature.com/articles/nature13173).

```{r testdata, echo=TRUE, message=FALSE}
library("scTGIF")
library("SingleCellExperiment")
library("GSEABase")
library("msigdbr")

data("DistalLungEpithelium")
data("pca.DistalLungEpithelium")
data("label.DistalLungEpithelium")
```

Although this data is still annotated and the cell type label is provided,
`r Biocpkg("scTGIF")` does not rely on this information.

```{r testdata2, echo=TRUE, fig.width=7, fig.height=7}
par(ask=FALSE)
plot(pca.DistalLungEpithelium, col=label.DistalLungEpithelium, pch=16,
    main="Distal lung epithelium dataset", xlab="PCA1", ylab="PCA2", bty="n")
text(0.1, 0.05, "AT1", col="#FF7F00", cex=2)
text(0.07, -0.15, "AT2", col="#E41A1C", cex=2)
text(0.13, -0.04, "BP", col="#A65628", cex=2)
text(0.125, -0.15, "Clara", col="#377EB8", cex=2)
text(0.09, -0.2, "Cilliated", col="#4DAF4A", cex=2)
```

To combine with the gene expression and the related gene function,
we suppose the gene function data is summarized as the object of
`r Biocpkg("GSEABase")`.
This data is directly downloadable from MSigDB and can be imported like
gmt <- GSEABase::getGmt("/YOURPATH/h.all.v6.0.entrez.gmt")

Note that `r Biocpkg("scTGIF")` only supports NCBI Gene IDs (Entrez IDs)
for now.
When the scRNA-Seq is not about human, the situation is more complicated.
Here, we use `r CRANpkg("msigdbr")` package to retrieve
the mouse MSigDB genesets like below.

```{r gmt, echo=TRUE}
m_df = msigdbr(species = "Mus musculus",
    category = "H")[, c("gs_name", "entrez_gene")]

hallmark = unique(m_df$gs_name)
gsc <- lapply(hallmark, function(h){
    target = which(m_df$gs_name == h)
    geneIds = unique(as.character(m_df$entrez_gene[target]))
    GeneSet(setName=h, geneIds)
})
gmt = GeneSetCollection(gsc)
gmt = gmt[1:10] # Reduced for this demo
```

### Parameter setting : settingTGIF

Next, the data matrix is converted to the object of
`r Biocpkg("SingleCellExperiment")` package,
and the 2D coordinates are registered as the reducedDims slot.

```{r setting, echo=TRUE}
sce <- SingleCellExperiment(assays = list(counts = DistalLungEpithelium))
reducedDims(sce) <- SimpleList(PCA=pca.DistalLungEpithelium)
```

Although the default mode of `r Biocpkg("scTGIF")` use `count` slot as
the input matrix,
the normalized gene expression data can also be specified.
In such a case, we recommend using `normcounts` slot to register the data.

```{r setting2, echo=TRUE}
CPMED <- function(input){
    libsize <- colSums(input)
    median(libsize) * t(t(input) / libsize)
}
normcounts(sce) <- log10(CPMED(counts(sce)) + 1)
```

After the registration of the data in `sce`,
`settingTGIF` will work like below.

```{r setting3, echo=TRUE}
settingTGIF(sce, gmt, reducedDimNames="PCA", assayNames="normcounts")
```

### Calculate attention maps and map-related gene functions: calcTGIF

After the setting above,
`calcTGIF` calculates the jNMF with the two matrices described above.

```{r calc, echo=TRUE}
calcTGIF(sce, ndim=3)
```

### HTML Report : reportTGIF

Finally, `reportTGIF` generates the HTML report to summarize
the result of jNMF.

```{r, report, echo=TRUE}
reportTGIF(sce,
    html.open=FALSE,
    title="scTGIF Report for DistalLungEpithelium dataset",
    author="Koki Tsuyuzaki")
```

Since this function takes some time,
please type `example("reportTGIF")` by your own environment.

# Session information {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

\name{reportTGIF}
\alias{reportTGIF}
\docType{methods}
\alias{reportTGIF,SingleCellExperiment-method}
\alias{reportTGIF}
\title{
Function for reporting the result of \code{\link{calcTGIF}} function
}
\description{
\code{\link{calcTGIF}} function calculates what kind of cellular patterns
and functional patterns are contained in single-cell RNA-seq data and
\code{\link{reportTGIF}} function generates report of analytic result.
}
\usage{
reportTGIF(sce, out.dir=tempdir(), html.open=FALSE,
    title="The result of scTGIF",
    author="The person who runs this script",
    assayNames="counts")
}
\arguments{
\item{sce}{
A object generated by instantization of SingleCellExperiment-class.
}
\item{out.dir}{
Output directory user want to save the report (Default: tempdir()).
}
\item{html.open}{
Whether html is opened when \code{\link{reportTGIF}} is finished
(Default: FALSE)
}
\item{title}{
Title of report (Default: "The result of scTGIF")
}
\item{author}{
The name of user name (Default: "The person who runs this script")
}
\item{assayNames}{
The unit of gene expression for using scTGIF
(e.g. normcounts, cpm...etc) (Default: "counts").
}
}
\value{
Some file is generated to output directory user specified.
}
\author{
\packageAuthor{scTGIF}
}
\examples{
    if(interactive()){
        # Package loading
        library("SingleCellExperiment")
        library("GSEABase")
        library("msigdbr")

        # Test data
        data("DistalLungEpithelium")
        data("pca.DistalLungEpithelium")
        data("label.DistalLungEpithelium")

        # Test data
        par(ask=FALSE)
        plot(pca.DistalLungEpithelium, col=label.DistalLungEpithelium, pch=16,
            main="Distal lung epithelium dataset", xlab="PCA1",
            ylab="PCA2", bty="n")
        text(0.1, 0.05, "AT1", col="#FF7F00", cex=2)
        text(0.07, -0.15, "AT2", col="#E41A1C", cex=2)
        text(0.13, -0.04, "BP", col="#A65628", cex=2)
        text(0.125, -0.15, "Clara", col="#377EB8", cex=2)
        text(0.09, -0.2, "Cilliated", col="#4DAF4A", cex=2)

        # Load the gmt file from MSigDB
        # Only "Entrez Gene ID" can be used in scTGIF
        # e.g. gmt <- GSEABase::getGmt(
        #     "/PATH/YOU/SAVED/THE/GMTFILES/h.all.v6.0.entrez.gmt")
        # Here we use msigdbr to retrieve mouse gene sets

        # Mouse gene set (NCBI Gene ID)
        m_df <- msigdbr(species = "Mus musculus", category = "H")[,
            c("gs_name", "entrez_gene")]

        # Convert to GeneSetCollection
        hallmark = unique(m_df$gs_name)
        gsc <- lapply(hallmark, function(h){
            target = which(m_df$gs_name == h)
            geneIds = unique(as.character(m_df$entrez_gene[target]))
            GeneSet(setName=h, geneIds)
        })
        gmt <- GeneSetCollection(gsc)

        # SingleCellExperiment-class
        sce <- SingleCellExperiment(
            assays = list(counts = DistalLungEpithelium))
        reducedDims(sce) <- SimpleList(PCA=pca.DistalLungEpithelium)

        # User's Original Normalization Function
        CPMED <- function(input){
            libsize <- colSums(input)
            median(libsize) * t(t(input) / libsize)
        }
        # Normalization
        normcounts(sce) <- log10(CPMED(counts(sce)) + 1)

        # Registration of required information into metadata(sce)
        settingTGIF(sce, gmt, reducedDimNames="PCA",
            assayNames="normcounts")

        # Functional Annotation based on jNMF
        calcTGIF(sce, ndim=7)

        # HTML Reprt
        reportTGIF(sce,
            html.open=TRUE,
            title="scTGIF Report for DistalLungEpithelium dataset",
            author="Koki Tsuyuzaki")
    }
}

\keyword{methods}

\name{calcTGIF}
\alias{calcTGIF}
\docType{methods}
\alias{calcTGIF,SingleCellExperiment-method}
\alias{calcTGIF}
\title{
Function for connecting cellular patterns and functional patterns using jNMF
}
\description{
\code{\link{calcTGIF}} function calculates what kind of
cellular patterns and functional patterns are contained in
single-cell RNA-seq data and \code{\link{reportTGIF}} function
generates report of analytic result.
}
\usage{
calcTGIF(sce, ndim, verbose=FALSE, droplet=TRUE)
}
\arguments{
\item{sce}{
A object generated by instantization of SingleCellExperiment-class.
}
\item{ndim}{
The number of low-dimension of joint NMF algorithm.
}
\item{verbose}{
The verbose parameter for nnTensor::jNMF (Default: FALSE).
}
\item{droplet}{
Whether Droplet-based single-cell RNA-Seq or not (Default: TRUE).
}
}
\value{
The result is saved to metadata slot of SingleCellExperiment object.
}
\author{
\packageAuthor{scTGIF}
}
\examples{
showMethods("calcTGIF")
}

\keyword{methods}

\name{cellMarkerToGmt}
\alias{cellMarkerToGmt}
\docType{methods}
\title{
A function to convert the CellMarker data to GMT files.
}
\description{
The GMT (Gene Matrix Transposed file format : *.gmt) file is formatted by the Broad Institute (https://software.broadinstitute.org/cancer/software/gsea/wiki/index.php/Data_formats#GMT:_Gene_Matrix_Transposed_file_format_.28.2A.gmt.29). The data can be downloaded from the website of CellMarker (http://biocc.hrbmu.edu.cn/CellMarker).
}
\usage{
cellMarkerToGmt(infile, outfile,
  uniq.column=c("tissueType", "cellName"),
  geneid.type=c("geneID", "geneSymbol"))
}
\arguments{
\item{infile}{
The input file downloaded from CellMarker website
}
\item{outfile}{
The output GMT file converted from the CellMarker data
}
\item{uniq.column}{
The duplicated terms in the specified column are aggrgated as a row of GMT file (Default: geneID)
}
\item{geneid.type}{
Output gene identifier. (Default: geneID)
}
}
\value{
\item{output}{
A GMT file is generated.
}
}
\author{
\packageAuthor{scTGIF}
}
\examples{
  library("GSEABase")

  tmp <- tempdir()
  infile1 = paste0(tmp, "/Human_cell_markers.txt")
  outfile1_1 = paste0(tmp, "/Human_cell_markers_1.gmt")
  outfile1_2 = paste0(tmp, "/Human_cell_markers_2.gmt")
  outfile1_3 = paste0(tmp, "/Human_cell_markers_3.gmt")
  outfile1_4 = paste0(tmp, "/Human_cell_markers_4.gmt")

  sink(infile1)
  cat("speciesType\ttissueType\tUberonOntologyID\tcancerType\tcellType\tcellName\tCellOntologyID\tcellMarker\tgeneSymbol\tgeneID\tproteinName\tproteinID\tmarkerResource\tPMID\tCompany\n")
  cat("Human\tKidney\tUBERON_0002113\tNormal\tNormal cell\tProximal tubular cell\tNA\tIntestinal Alkaline Phosphatase\tALPI\t248\tPPBI\tP09923\tExperiment\t9263997\tNA\n")
  cat("Human\tLiver\tUBERON_0002107\tNormal\tNormal cell\tIto cell (hepatic stellate cell)\tCL_0000632\tSynaptophysin\tSYP\t6855\tSYPH\tP08247\tExperiment\t10595912\tNA\n")
  cat("Human\tEndometrium\tUBERON_0001295\tNormal\tNormal cell\tTrophoblast cell\tCL_0000351\tCEACAM1\tCEACAM1\t634\tCEAM1\tP13688\tExperiment\t10751340\tNA\n")
  cat("Human\tGerm\tUBERON_0000923\tNormal\tNormal cell\tPrimordial germ cell\tCL_0000670\tVASA\tDDX4\t54514\tDDX4\tQ9NQI0\tExperiment\t10920202\tNA\n")
  cat("Human\tCorneal epithelium\tUBERON_0001772\tNormal\tNormal cell\tEpithelial cell\tCL_0000066\tKLF6\tKLF6\t1316\tKLF6\tQ99612\tExperiment\t12407152\tNA\n")
  cat("Human\tPlacenta\tUBERON_0001987\tNormal\tNormal cell\tCytotrophoblast\tCL_0000351\tFGF10\tFGF10\t2255\tFGF10\tO15520\tExperiment\t15950061\tNA\n")
  cat("Human\tPeriosteum\tUBERON_0002515\tNormal\tNormal cell\tPeriosteum-derived progenitor cell\tNA\tCD166, CD45, CD9, CD90\tALCAM, PTPRC, CD9, THY1\t214, 5788, 928, 7070\tCD166, PTPRC, CD9, THY1\tQ13740, P08575, P21926, P04216\tExperiment\t15977065\tNA\n")
  cat("Human\tAmniotic membrane\tUBERON_0009742\tNormal\tNormal cell\tAmnion epithelial cell\tCL_0002536\tNANOG, OCT3/4\tNANOG, POU5F1\t79923, 5460\tNANOG, PO5F1\tQ9H9S0, Q01860\tExperiment\t16081662\tNA\n")
  cat("Human\tPrimitive streak\tUBERON_0004341\tNormal\tNormal cell\tPrimitive streak cell\tNA\tLHX1, MIXL1\tLHX1, MIXL1\t3975, 83881\tLHX1, MIXL1\tP48742, Q9H2W2\tExperiment\t16258519\tNA\n")
  sink()

  cellMarkerToGmt(infile1, outfile1_1, uniq.column=c("tissueType"),
    geneid.type=c("geneID"))
  cellMarkerToGmt(infile1, outfile1_2, uniq.column=c("tissueType"),
    geneid.type=c("geneSymbol"))
  cellMarkerToGmt(infile1, outfile1_3, uniq.column=c("cellName"),
    geneid.type=c("geneID"))
  cellMarkerToGmt(infile1, outfile1_4, uniq.column=c("cellName"),
    geneid.type=c("geneSymbol"))

  gmt1_1 <- getGmt(outfile1_1)
  gmt1_2 <- getGmt(outfile1_2)
  gmt1_3 <- getGmt(outfile1_3)
  gmt1_4 <- getGmt(outfile1_4)
}

\keyword{methods}

\name{settingTGIF}
\alias{settingTGIF}
\docType{methods}
\alias{settingTGIF,SingleCellExperiment-method}
\alias{settingTGIF}
\title{
Paramter setting for scTGIF
}
\description{
All parameters is saved to metadata slot of SingleCellExperiment object.
}
\usage{
settingTGIF(sce, gmt, reducedDimNames, assayNames="counts", nbins=40)
}
\arguments{
\item{sce}{
A object generated by instantization of SingleCellExperiment-class.
}
\item{gmt}{
Object generated from GSEABase::getGmt function.
GMT file can be downloaded from MSigDB web
(site http://software.broadinstitute.org/gsea/login.jsp#msigdb).
Please confirm that the gmt file contains Human Entrez Gene ID,
not gene symbol. Also confirm that the DataMatrix has Human Entrez Gene ID.
}
\item{reducedDimNames}{
The names of reducedDim(sce) that user want use in scTGIF.
}
\item{assayNames}{
The unit of gene expression for using scTGIF
(e.g. normcounts, cpm...etc) (Default: "counts").
}
\item{nbins}{
The number of bins of schex (Default: 40).
}
}
\value{
The result is saved to metadata slot of SingleCellExperiment object.
}
\author{
\packageAuthor{scTGIF}
}
\examples{
showMethods("settingTGIF")
}

\keyword{methods}

\name{scTGIF-package}
\alias{scTGIF-package}
\alias{scTGIF}
\docType{package}
\title{
\packageTitle{scTGIF}
}
\description{
\packageDescription{scTGIF}
}
\details{

The DESCRIPTION file:
\packageDESCRIPTION{scTGIF}
\packageIndices{scTGIF}
\code{\link{calcTGIF}} function calculates what kind of
cellular patterns and functional patterns are contained
in single-cell RNA-seq data and \code{\link{reportTGIF}}
function generates report of analytic result.
The algorithm is based on joint NMF, which is implemented in nnTensor package.
}
\author{
\packageAuthor{scTGIF}

Maintainer: \packageMaintainer{scTGIF}
}
\references{
Dominic Grun, Anna Lyubimova, Lennart Kester, Kay Wiebrands,
Onur Basak, Nobuo Sasaki, Hans Clevers, Alexander van Oudenaarden
(2015) Single-cell messenger RNA sequencing reveals rare
intestinal cell types. \emph{Nature}, \bold{525}: 251-255
}
\keyword{ package }

\name{convertRowID}
\alias{convertRowID}
\docType{methods}
\title{
A function to change the row names of a matrix.
}
\description{
To avoid to specify the duplicated row names against matrix, multiple aggregation rules are implemented.
}
\usage{
convertRowID(input, rowID, LtoR,
    aggr.rule=c("sum", "mean", "large.mean", "large.var", "large.cv2"))
}
\arguments{
\item{input}{
A matrix filled with number (n * m).
}
\item{rowID}{
A vector to specify the row names of input (length: n).
}
\item{LtoR}{
A corresponding table to covert the row names of input as different type of IDs.
(Left: current row names -> Right: new row names)
}
\item{aggr.rule}{
The aggregation rule to change the row names of input and collapse/select the values, if the row names changed by LtoR are duplicated.

sum: Collapses multiple row vectors by summation.
mean: Collapses multiple row vectors by mean.
large.mean: Select a vector having the largest mean in the duplicated vectors.
large.var: Select a vector having the largest variance in the duplicated vectors.
large.cv2: Select a vector having the largest CV2 in the duplicated vectors.
}
}
\value{
\item{output}{
A matrix, in which the row names are changed, according to the aggregation rule user specified.
}
\item{ctable}{
The corresponding table explaining the relationship between previous row names and changed row names of input.
}
}
\author{
\packageAuthor{scTGIF}
}
\examples{
    input <- matrix(1:20, nrow=4, ncol=5)
    rowID <- c("A", "B", "C", "D")
    LtoR <- rbind(
      c("A", "3"),
      c("B", "2"),
      c("C", "4"),
      c("D", "7"))
    (input2 <- convertRowID(input, rowID, LtoR, "sum"))
    (input3 <- convertRowID(input, rowID, LtoR, "mean"))
    (input4 <- convertRowID(input, rowID, LtoR, "large.mean"))
    (input5 <- convertRowID(input, rowID, LtoR, "large.var"))
    (input6 <- convertRowID(input, rowID, LtoR, "large.cv2"))
}

\keyword{methods}

\name{pca.DistalLungEpithelium}
\alias{pca.DistalLungEpithelium}
\docType{data}
\title{
The result of PCA of the DistalLungEpithelium dataset.
}
\description{
A matrix having 80 (cells) * 2 (PCs) elements.
}
\usage{data("pca.DistalLungEpithelium")}

\references{
Treutlein, B. et al. (2014) Reconstructing lineage hierarchies of the
distal lung epithelium using single-cell RNA-seq. \emph{Nature}
\bold{509}, 371-375
}
\examples{
data("pca.DistalLungEpithelium")
}
\keyword{datasets}

\name{DistalLungEpithelium}
\alias{DistalLungEpithelium}
\docType{data}
\title{
Gene expression matrix of DistalLungEpithelium dataset containing five cluster.
}
\description{
A data frame with 3397 rows (genes) with following 80 columns (cells).

The data is downloaded as supplementary information of the distal lung
epithelium paper (https://www.nature.com/articles/nature13173).

Low-expressed genes are filted.

\emph{All Gene ID is converted to Human Entrez Gene ID for
applying the data to scTGIF.}
}
\usage{data("DistalLungEpithelium")}

\source{
\url{http://www.nature.com/nbt/journal/v33/n2/full/nbt.3102.html}
}
\references{
Treutlein, B. et al. (2014) Reconstructing lineage hierarchies of the
distal lung epithelium using single-cell RNA-seq. \emph{Nature}
\bold{509}, 371-375
}
\examples{
data("DistalLungEpithelium")
}
\keyword{datasets}

\name{label.DistalLungEpithelium}
\alias{label.DistalLungEpithelium}
\docType{data}
\title{
Cellular label of DistalLungEpithelium dataset containing five cluster.
}
\description{
A vector containing 80 elements (cells).
}
\usage{data("label.DistalLungEpithelium")}

\references{
Treutlein, B. et al. (2014) Reconstructing lineage hierarchies of the
distal lung epithelium using single-cell RNA-seq. \emph{Nature}
\bold{509}, 371-375
}
\examples{
data("label.DistalLungEpithelium")
}
\keyword{datasets}
